=== debian/changelog ===
uncalled (2.2+ds-1) unstable; urgency=high

  * Source-only upload.
  * Added patch for 32-bit architectures.

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 08 Feb 2021 09:22:50 +0100

uncalled (2.2+ds-1~0exp) experimental; urgency=medium

  * Initial release. (Closes: #982142)

 -- Michael R. Crusoe <crusoe@debian.org>  Sat, 06 Feb 2021 20:34:48 +0100
