=== debian/control ===
Source: uncalled
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael R. Crusoe <crusoe@debian.org>
Build-Depends: debhelper-compat (= 13),
               python3-all,
               python3-all-dev,
               python3-setuptools,
#              python3-read-until,
               python3-pybind11,
               python3-numpy,
               pdqsort-dev,
               dh-python,
               libbwa-dev,
               libhdf5-dev,
               pkg-config,
               libfast5-dev
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/med-team/uncalled
Vcs-Git: https://salsa.debian.org/med-team/uncalled.git
Homepage: https://github.com/skovaka/UNCALLED
Rules-Requires-Root: no

Package: uncalled
Architecture: any
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}, python3-numpy
Description: Utility for Nanopore Current Alignment to Large Expanses of DNA
 Streaming algorithm for mapping raw nanopore signal to DNA references
 .
 Enables real-time enrichment or depletion on Oxford Nanopore Technologies
 (ONT) MinION runs via ReadUntil.
 .
 Also supports standalone signal mapping of fast5 reads
