## uncalled 2.2+ds1

=== debian/changelog ===
uncalled (2.2+ds1-1) unstable; urgency=medium

  * Team upload
  * Use Debian packaged toml11

 -- Andreas Tille <tille@debian.org>  Wed, 16 Feb 2022 15:40:49 +0100

uncalled (2.2+ds-3) unstable; urgency=medium

  * Team upload.
  * Really fix watch file

 -- Andreas Tille <tille@debian.org>  Thu, 03 Feb 2022 10:13:48 +0100

uncalled (2.2+ds-2) unstable; urgency=medium

  * Team upload.
  * Fix watchfile to detect new versions on github (routine-update)
  * Standards-Version: 4.6.0 (routine-update)
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Enable building the package for developers who did not installed
    python3-pybind11 on their local machine

 -- Andreas Tille <tille@debian.org>  Wed, 29 Sep 2021 18:44:48 +0200
