=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8
export PYBUILD_NAME=uncalled

# for hardening you might like to uncomment this:
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_auto_clean:
	if dpkg -s python3-pybind11 >/dev/null 2>/dev/null ; then \
	    dh_auto_clean ; \
	else \
	    echo "skip dh_auto_clean since python3-pybind11 is not installed on your local machine" ; \
	fi
