## uncalled 2.3%2Bds

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,9 @@
 
 # for hardening you might like to uncomment this:
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
+
+# Building with HDF5/1.14.4.3, forwarded: https://github.com/skovaka/UNCALLED/issues/60
+export DEB_CPPFLAGS_MAINT_APPEND = -DH5_USE_110_API
 
 %:
 	dh $@ --with python3 --buildsystem=pybuild
