=== debian/changelog ===
uncalled (2.3+ds-3) unstable; urgency=medium

  * Team upload
  * debian_toml11.patch: normalize last-update timestamp.
  * skip_read_until: unfuzz patch.
  * syntax-warning.patch: new: fix SyntaxWarnings. (Closes: #1087156)

 -- Étienne Mollier <emollier@debian.org>  Tue, 03 Dec 2024 20:44:38 +0100

uncalled (2.3+ds-2) unstable; urgency=medium

  * Team upload
  * Building with HDF5/1.14.4.3 (Closes: #1078982)
  * Raising Standards version to 4.7.0 (no change)
  * Build-depending on pkgconf instead of obsolete pkg-config
  * Removing debian/files from the packaging

 -- Pierre Gruet <pgt@debian.org>  Wed, 21 Aug 2024 17:42:02 +0200

uncalled (2.3+ds-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Team upload.
  * New upstream version (Refreshed patches)
  * Standards-Version: 4.6.2 (routine-update)
  * Set upstream metadata fields: Bug-Submit.

  [ Nilesh Patra ]
  * Update patch to link to hdf5 lib on system
    + The upstream way to summon extra_objects for it is
      not relevant to us (downstream).

 -- Andreas Tille <tille@debian.org>  Fri, 14 Jul 2023 07:55:11 +0200
