=== debian/control ===
--- 
+++ 
@@ -14,9 +14,10 @@
                dh-python,
                libbwa-dev,
                libhdf5-dev,
-               pkg-config,
-               libfast5-dev
-Standards-Version: 4.5.1
+               pkgconf,
+               libfast5-dev,
+               libtoml11-dev
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/med-team/uncalled
 Vcs-Git: https://salsa.debian.org/med-team/uncalled.git
 Homepage: https://github.com/skovaka/UNCALLED
